#!/usr/bin/env python

from vRecurrence import *

def show(l):
    for x in l:
        print x
    print

qualifiers = [
    ("YEARLY", {"interval" : 1})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 11, 2)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((2003, 12, 24))
print len(l) == 7, len(l)
print l[0] == (1997, 11, 2), l[0]
print l[-1] == (2003, 11, 2), l[-1]
print

qualifiers = [
    ("YEARLY", {"interval" : 2}),
    ("BYMONTH", {"values" : [1]}),
    ("BYDAY", {"values" : [6]}),
    ("BYHOUR", {"values" : [8, 9]}),
    ("BYMINUTE", {"values" : [30]})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 1, 5, 8, 30, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((2003, 12, 24, 0, 0, 0))
print len(l) == 34, len(l)
print l[0] == (1997, 1, 4, 8, 30, 0), l[0]
print l[-1] == (2003, 1, 25, 9, 30, 0), l[-1]
print

qualifiers = [
    ("DAILY", {"interval" : 1})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24), 10)
print len(l) == 10, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 9, 11, 9, 0, 0), l[-1]
print

qualifiers = [
    ("DAILY", {"interval" : 1})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0))
print len(l) == 113, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 12, 23, 9, 0, 0), l[-1]
print

qualifiers = [
    ("DAILY", {"interval" : 2})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0))
print len(l) == 57, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 12, 23, 9, 0, 0), l[-1]
print

qualifiers = [
    ("WEEKLY", {"interval" : 1})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0))
print len(l) == 17, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 12, 23, 9, 0, 0), l[-1]
print

qualifiers = [
    ("DAILY", {"interval" : 10})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0), 5)
print len(l) == 5, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 10, 12, 9, 0, 0), l[-1]
print

qualifiers = [
    ("YEARLY", {"interval" : 1}),
    ("BYMONTH", {"values" : [1]}),
    ("BYDAY", {"values" : [1, 2, 3, 4, 5, 6, 7]})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1998, 1, 1, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((2000, 1, 31, 14, 0, 0))
print len(l) == 93, len(l)
print l[0] == (1998, 1, 1, 9, 0, 0), l[0]
print l[-1] == (2000, 1, 31, 9, 0, 0), l[-1]
print

qualifiers = [
    ("DAILY", {"interval" : 1}),
    ("BYMONTH", {"values" : [1]})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1998, 1, 1, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((2000, 1, 31, 14, 0, 0))
print len(l) == 93, len(l)
print l[0] == (1998, 1, 1, 9, 0, 0), l[0]
print l[-1] == (2000, 1, 31, 9, 0, 0), l[-1]
print

qualifiers = [
    ("WEEKLY", {"interval" : 1})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0), 10)
print len(l) == 10, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 11, 4, 9, 0, 0), l[-1]
print

qualifiers = [
    ("WEEKLY", {"interval" : 1})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0))
print len(l) == 17, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 12, 23, 9, 0, 0), l[-1]
print

qualifiers = [
    ("WEEKLY", {"interval" : 2})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1998, 2, 20, 0, 0, 0))
print len(l) == 13, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1998, 2, 17, 9, 0, 0), l[-1]
print

qualifiers = [
    ("WEEKLY", {"interval" : 1}),
    ("BYDAY", {"values" : [2, 4]})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 10, 7, 9, 0, 0))
print len(l) == 10, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 10, 2, 9, 0, 0), l[-1]
print

qualifiers = [
    ("WEEKLY", {"interval" : 1}),
    ("BYDAY", {"values" : [2, 4]})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 2, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0), 10)
print len(l) == 10, len(l)
print l[0] == (1997, 9, 2, 9, 0, 0), l[0]
print l[-1] == (1997, 10, 2, 9, 0, 0), l[-1]
print

qualifiers = [
    ("WEEKLY", {"interval" : 2}),
    ("BYDAY", {"values" : [1, 3, 5]})
    ]

l = order_qualifiers(qualifiers)
show(l)
dt = (1997, 9, 1, 9, 0, 0)
l = get_datetime_structure(dt)
show(l)
l = combine_datetime_with_qualifiers(dt, qualifiers)
show(l)

s = process(l)
l = s.materialise((1997, 12, 24, 0, 0, 0))
print len(l) == 25, len(l)
print l[0] == (1997, 9, 1, 9, 0, 0), l[0]
print l[-1] == (1997, 12, 22, 9, 0, 0), l[-1]
print

# vim: tabstop=4 expandtab shiftwidth=4
